#include "stdafx.h"
#include ".\dipswitch.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL CDIPSwitch::Create(CWnd* pParentWnd, UINT uiFrameResID)
{
	m_bCreatetd = FALSE;
	if(pParentWnd)
	{
		CWnd *pWnd = pParentWnd->GetDlgItem(uiFrameResID);
		if(pWnd)
		{
			CRect rc;
			pWnd->GetWindowRect(&rc);
			pParentWnd->ScreenToClient(&rc);
			m_wndShield.Create(NULL,_T(""),WS_VISIBLE,rc,pParentWnd,NULL);

			int nSliderWidth = 30;
			CRect rcONLbl(rc.left+3, rc.top+5, rc.left+nSliderWidth, rc.top+5+nSliderWidth);
			m_lblON.Create(_T("ON"), WS_CHILD|WS_VISIBLE|SS_CENTER, rcONLbl, pParentWnd);
			m_lblON.SetFont(pParentWnd->GetFont());

			for(int i=0; i<6; i++)
			{
				if(!::IsWindow(m_sliders[i].GetSafeHwnd()))
				{
					CRect rc(CPoint(rc.left+40+nSliderWidth*i, rc.top+10), CSize(nSliderWidth, rc.bottom-rc.top-20));
					m_sliders[i].Create(TBS_NOTICKS | TBS_BOTH | TBS_VERT | WS_CHILD | WS_VISIBLE, rc, pParentWnd, -1);
					m_sliders[i].SetRange(0,1);
				}
				m_sliders[i].SetPos(1);
			}
			m_bCreatetd = TRUE;
		}
	}
	return m_bCreatetd;
}	

void CDIPSwitch::SetState(DWORD dwState)
{
	if(m_bCreatetd)
	{
		for(int i=0; i<6; i++)
		{
			m_sliders[i].SetPos(~(dwState>>i)&1);
		}
	}
}

void CDIPSwitch::Destroy()
{
	if(::IsWindow(m_lblON.GetSafeHwnd()))
		m_lblON.DestroyWindow();

	if(::IsWindow(m_wndShield.GetSafeHwnd()))
		m_wndShield.DestroyWindow();

	for(int i=0;i<6;i++)
	{
		if(::IsWindow(m_sliders[i].GetSafeHwnd()))
		{
			m_sliders[i].DestroyWindow();
		}
	}
}