// MySliderNewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MySliderNew.h"
#include "MySliderNewDlg.h"
#include "MicroKey.h"
#include ".\myslidernewdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMySliderNewDlg dialog

CMySliderNewDlg::CMySliderNewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMySliderNewDlg::IDD, pParent)
	, m_dwState(0)
	, m_dwSampleState(0)
	, m_dwChanAAState(0)
	, m_dwChanABState(0)
	, m_dwChanACState(0)
{
	//{{AFX_DATA_INIT(CMySliderNewDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMySliderNewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMySliderNewDlg)
	DDX_Text(pDX, IDC_STATE_ED, m_dwState);
	DDX_Text(pDX, IDC_SAMPLE_STATE_ED, m_dwSampleState);
	DDX_Text(pDX, IDC_CHAN_AA_STATE_ED, m_dwChanAAState);
	DDX_Text(pDX, IDC_CHAN_AB_STATE_ED, m_dwChanABState);
	DDX_Text(pDX, IDC_CHAN_AC_STATE_ED, m_dwChanACState);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMySliderNewDlg, CDialog)
	//{{AFX_MSG_MAP(CMySliderNewDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SET_SAMPLE_STATE_BTN, OnBnClickedSetSampleStateBtn)
	ON_BN_CLICKED(IDC_SET_CHAN_AA_STATE_BTN, OnBnClickedSetChanAaStateBtn)
	ON_BN_CLICKED(IDC_SET_CHAN_AB_STATE_BTN, OnBnClickedSetChanAbStateBtn)
	ON_BN_CLICKED(IDC_SET_CHAN_AC_STATE_BTN, OnBnClickedSetChanAcStateBtn)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMySliderNewDlg message handlers

BOOL CMySliderNewDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_dipSample.Create(this, IDC_SAMPLE_DIP);
	m_dipChanAA.Create(this, IDC_CHANNEL_AA_DIP);
	m_dipChanAB.Create(this, IDC_CHANNEL_AB_DIP);
	m_dipChanAC.Create(this, IDC_CHANNEL_AC_DIP);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMySliderNewDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMySliderNewDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMySliderNewDlg::OnButton1() 
{
	UpdateData(TRUE);
	CRect rc;
    GetDlgItem(IDC_00)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	CMK.CreatMicroKey(this, rc, m_dwState,0);
}

void CMySliderNewDlg::OnButton2() 
{
	UpdateData(TRUE);

	CRect rc;

	GetDlgItem(IDC_01)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	CMK.CreatMicroKey(this, rc, m_dwState, 6);

	GetDlgItem(IDC_0)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	CMK.CreatMicroKey(this, rc,  m_dwState, 24);

	Invalidate();
}

void CMySliderNewDlg::OnButton3() 
{
	UpdateData(TRUE);
	CRect rc;
    GetDlgItem(IDC_02)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	CMK.CreatMicroKey(this, rc, m_dwState,12);
}

void CMySliderNewDlg::OnButton4() 
{
	UpdateData(TRUE);
	CRect rc;
    GetDlgItem(IDC_03)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	CMK.CreatMicroKey(this, rc, m_dwState,18);
}

void CMySliderNewDlg::OnDestroy()
{
	CMK.DeleteMicroKey();

	m_dipSample.Destroy();
	m_dipChanAA.Destroy();
	m_dipChanAB.Destroy();
	m_dipChanAC.Destroy();

	CDialog::OnDestroy();
}

void CMySliderNewDlg::OnBnClickedSetSampleStateBtn()
{
	if(UpdateData(TRUE))
	{
		m_dipSample.SetState(m_dwSampleState);
	}
}

void CMySliderNewDlg::OnBnClickedSetChanAaStateBtn()
{
	if(UpdateData(TRUE))
	{
		m_dipChanAA.SetState(m_dwChanAAState);
	}
}

void CMySliderNewDlg::OnBnClickedSetChanAbStateBtn()
{
	if(UpdateData(TRUE))
	{
		m_dipChanAB.SetState(m_dwChanABState);
	}
}

void CMySliderNewDlg::OnBnClickedSetChanAcStateBtn()
{
	if(UpdateData(TRUE))
	{
		m_dipChanAC.SetState(m_dwChanACState);
	}
}
